
%% 1st cell. Data format. (Please run this code cell by cell and look at the comments):
close all
clear all
clc

data=[1 0.6 77 76 1
1 1.3 53 71 1
1 2.4 45 71 1
1 2.5 57 78 0
1 3.2 58 74 1
1 3.2 51 77 0
1 3.3 76 74 1
1 3.3 63 77 0
1 3.5 43 71 1
1 3.5 60 73 1
1 4 52 71 1
1 4 63 76 1
1 4.3 86 74 1
1 4.5 48 76 0
1 4.5 68 76 0
1 5.3 81 72 1
1 5.5 70 75 0
1 5.9 58 75 0
1 5.9 47 75 0
1 6 75 73 1
1 6.1 77 75 0
1 6.2 64 75 0
1 6.4 77 72 1
1 6.5 67 70 1
1 6.5 79 74 0
1 6.7 61 74 0
1 7 66 74 0
1 7.4 68 71 1
1 7.4 73 73 0
1 8.1 56 73 0
1 8.1 73 73 0
1 9.6 58 71 0
1 10.7 68 70 0
2 0.2 86 74 1
2 1.8 64 77 1
2 2 63 75 1
2 2.2 71 78 0
2 2.6 67 78 0
2 3.3 51 77 0
2 3.6 70 77 1
2 3.6 72 77 0
2 4 81 71 1
2 4.3 47 76 0
2 4.3 64 76 0
2 5 66 76 0
2 6.2 74 72 1
2 7 62 73 1
2 7.5 50 73 0
2 7.6 53 73 0
2 9.3 61 71 0
3 0.3 49 72 1
3 0.3 71 76 1
3 0.5 57 74 1
3 0.7 79 77 1
3 0.8 82 74 1
3 1 49 76 1
3 1.3 60 76 1
3 1.6 64 72 1
3 1.8 74 71 1
3 1.9 72 74 1
3 1.9 53 74 1
3 3.2 54 75 1
3 3.5 81 74 1
3 3.7 52 77 0
3 4.5 66 76 0
3 4.8 54 76 0
3 4.8 63 76 0
3 5 59 73 1
3 5 49 76 0
3 5.1 69 76 0
3 6.3 70 72 1
3 6.4 65 72 1
3 6.5 65 74 0
3 7.8 68 72 1
3 8 78 73 0
3 9.3 69 71 0
3 10.1 51 71 0
4 0.1 65 72 1
4 0.3 71 76 1
4 0.4 76 77 1
4 0.8 65 76 1
4 0.8 78 77 1
4 1 41 77 1
4 1.5 68 73 1
4 2 69 76 1
4 2.3 62 71 1
4 2.9 74 78 0
4 3.6 71 75 1
4 3.8 84 74 1
4 4.3 48 76 0];

stage=data(:,1);time=data(:,2); %derive the variables for analysis from the data matrix.
age=data(:,3);status=data(:,5); 
status=status.*(-1)+1;   % in the original data set code 0 is for censoring and 1 for death. MATLAB needs the opposite coding. For the HCNS function this is not a problem since the user can define the event.
Z=[(stage==2) (stage==3) (stage==4) age]; %build the covariate matrix
%Z=[(stage==2) (stage==3) (stage==4) ]; %build the covariate matrix
%Z=[(stage==2) (stage==3) (stage==4) age (stage==2).*age (stage==3).*age (stage==4).*age]; %build the covariate matrix
%Z=age;
%Now the data are ready for analysis: [time, status, Z]

%% 2nd cell

%Fit cox model to derive baseline S0 (for Z=0):
[bcox logL H stats] = coxphfit(Z,time,'censoring',status,'baseline',0);
S0cox=exp(-H(:,2)); % this is the cox baseline survival.

%Apply the HCNS routine:
%We use 'auto' knot placement,
%an optimal 18-gon to capture the monotonicity region (since k is set equal to 2)
%and the polygon used is of the form (8k+2).
%A plot of the cumulative hazard is also requested.
[bhat H0 F0 S0 KMdist knots gcoxhat]=HCNS(time, status, 0, Z, 'auto',2,[],  'cumulative hazard');
%g2=gcoxhat(1);g3=gcoxhat(2);g4=gcoxhat(3);gage=gcoxhat(4); %These are the cox coefs.

%Estimation procedure is now over.

%Run the diagnostics:
rj=HCNSresiduals(H0,gcoxhat,time,status,0,Z)



%% 3rd cell: Now reproduce the graphs of the paper in the Application section: just plot all survival curves together
close all %close all figures
gr=0:0.01:8.5; %construct a grid of points over which the survival estimates will be plotted.
figure
hold on
% Plot the HCNS survival estimates for each stage:
plot(gr,S0(gr).^(exp(gage.*mean(age))),'k','LineWidth',2)
plot(gr,S0(gr).^(exp(gage.*mean(age)+g2)),'k','LineWidth',2)
plot(gr,S0(gr).^(exp(gage.*mean(age)+g3)),'k','LineWidth',2)
plot(gr,S0(gr).^(exp(gage.*mean(age)+g4)),'k','LineWidth',2)

% Plot the Cox survival estimates for each stage:
stairs(H(:,1),S0cox.^(exp(gage.*mean(age))),'k')
stairs(H(:,1),S0cox.^(exp(gage.*mean(age)+g2)),'k')
stairs(H(:,1),S0cox.^(exp(gage.*mean(age)+g3)),'k')
stairs(H(:,1),S0cox.^(exp(gage.*mean(age)+g4)),'k')
xlabel('t');ylabel('S(t)')


%% 4th cell: Now derive the survival function for a specific profile of a patient:
%[0 0 0 mean(age)], that is 4th stage of cancer and mean(age).
close all  %close all figures
[bhat Hx Fx Sx KMdist knots gcoxhat]=HCNS(time, status, 0, Z, 'auto', 2,[], 'none', [0 0 0 mean(age)],'survivor')


%% 5th cell:
% Now fix the knots and ask for confidence intervals (based on 300 bootstrap sample) for the cumulative
% hazard (CIH), for the survival (CIS), as well as for the cumulative
% distribution (CIF), for a selected profile,([0 0 0 mean(age)], 
%that is 4th stage of cancer and mean(age).

%We ask to evaluate the confidence intervals at time points [1 2 3 4 5 6].

%The count will inform you how many bootstrap samples needed to be
%discarded (to gather 300 bootstrap samples) based on the criterion
%discard=10. Since 'discard' is set equal to 10, any bootstrap sample that will provide
%a cox coef outside the interval gcox+-10*std(gcox) will be discarded.
%This is done because for some bootstrap iteration all data might turn out
%to be censored (or all data for a specific covariate value). The cox coef
%might tend to infinity. Also problems when the last event of one category
%is earlier than the first event of the other during fitting a COx model
%may occur. By using the discard option you can discard these "unwanted"
%bootstrap sample. However caution is needed so as not to cause significant
%bias. 

%Of course count may be greater than the number of bootstrap samples
%gathered.


knots=[ 0.1000    0.1750    0.3000    3.5000    5.1500    7.8000]
[CIH CIS CIF count]=HCNSboots(time, status, 0, Z, knots, 2,[], [1:6], 300, 0.05, 10, [0 0 0 mean(age)])

%% 6th cell:
% The same thing but set some options for the built in coxphfit MATLAB
% function (this option will be active for every bootstrap sample):

%The "options" refer only to the underlying cox model fitted with coxphfit
%built in routine of MATLAB. Please check the coxphfit documentation for
%this option.

toler=10^(-7);
iter=1000;
options = statset('Display','final','TolX',toler,'TolFun',toler, 'TolBnd',toler, 'MaxIter', iter, 'MaxFunEvals', iter)


knots=[ 0.1000    0.1750    0.3000    3.5000    5.1500    7.8000]
[CIH CIS CIF count]=HCNSboots(time, status, 0,  Z, knots, 2, options, [1:6], 300, 0.05, 10, [0 0 0 mean(age)])




%% 7th cell:
%Now suppose that you had no idea where to place the knots, just use the
%auto procedure to derive the corresponding confidence intervals:(this may take some minutes
%depending on the machine you are using), since 420 minimizations are performed for each bootstrap sample.

%Progress messages will appear in the Command Window when there is 25%, 50%, 75%
%completion of the required calculations.


[CIH CIS CIF count]=HCNSboots(time, status, 0, Z, 'auto', 2,[], [1:6], 300, 0.05, 10,  [0 0 0 mean(age)])
%(In case you want to "break" the procedure press "Ctrl+C" in the Command Window)

