
close all %close all figures
clear all %clear all variables
clc       %clean the Command Window

n=300;
u=rand(n,1);  % Generate n number from the Uniform(0,1)
a=2;b=3;g=2;  %Set the values of the baseline survival, and cox coef g=2
z=exprnd(0.3,n,1); %Generate the covariate to be exponential distributed with mean 3
x=(-log(u)./(a^(-b).*exp(g.*z))).^(1./b); %Generate values from Cox model
c=exprnd(4,n,1); % Generate the censoring variable
status=(x>c);    % Derive the censoring indicator
xcen=min(x,c);   % Derive censored time values

level_of_censoring=mean(status)


%The data for analysis are the variables: time, status, z (the covariate)
[bhat H0 F0 S0 KMdist knots gcoxhat stats]=HCNS(xcen, status, 0, [z], 'auto',2,[], 'cumulative hazard')

figure
rj=H0(xcen).*exp(z.*gcoxhat)
[bhat Hr Fr Sr KMdist knots]=HCNS(rj, status ,0, [], 'auto', 2,[], 'cumulative hazard')

%%
figure
plot(Hr(sort(rj)),sort(rj),'or')
xlabel('r_j')
ylabel('HCNS at r_j')
title('HCNS based cox-snell residuals')
hold on
gr0=linspace(0,max(rj),500);
plot(gr0,gr0,'--k')





