

% Plot the approximation of the monotonicity region fro a given k
% This is also provided in the Appendix of the paper.
clear all
close all
clc



k=10; %Provide k and run.

%--everything will follow:

xc=2;yc=2; %center of the ellipse
theta=-pi/4; %tilt of the major axis

a=2.4494897462427740464363523642533;% major semi axis
b=sqrt(2);  % minor semi axis

N=12*k; %Chose how many points you want
N=N+1;
%----Apply Smith's algorithm to approximate the ellipse:


df=2*pi/(N-1);
CT=cos(theta);
ST=sin(theta);
CDP=cos(df);SDP=sin(df);CNDP=1;SNDP=0;

x=zeros(1,N);y=x;
for n=1:N
    xp=a*CNDP;yp=b*SNDP;
    x(n)=xc+xp*CT-yp*ST;
    y(n)=yc+xp*ST+yp*CT;
    
    TEMP=CNDP*CDP-SNDP*SDP;
    SNDP=SNDP*CDP+CNDP*SDP;
    CNDP=TEMP;
end


%Re-arrange the data so as the first point to be (x,y)=(3,0)
M=[x' y'];M(max(size(M)),:)=[]; M=circshift(M,k);
x=M(:,1);y=M(:,2);

%Plot the approximation of the ellipse:
hold on
plot(x,y,'-k')  
axis square
axis([0 4 0 4])

%Plot the approximation of the monotonicity region:
plot(x(1:(8*k+1)),y(1:(8*k+1)),'-k','LineWidth',2) 
plot([3 0 3 0], [3 3 0 0],'ok')
xlabel('\alpha');ylabel('b');
 
%Shade the approximated region:
fill([x(1:(8*k+1));0],[y(1:(8*k+1));0],[0.7,0.7,0.7]);alpha(0.50)
hold off
%title(['Approximation of monotnicity region for k=',num2str(k)])

%Finally the points of approximation of the monotonicity region are:
points_of_approximation=[[x(1:(8*k+1));0] [y(1:(8*k+1));0]]

hold on
plot([0 3], [3 3],'k')

plot([3 3], [3 0],'k')










